<?php
class leaguesite_handler_field_points extends views_handler_field_numeric{
	function construct(){
		parent::construct();
		$this->additional_fields['won'] = 'won';
    $this->additional_fields['lost'] = 'lost';
    $this->additional_fields['drawn'] = 'drawn';
    $this->additional_fields['bonus'] = 'bonus';
    $this->additional_fields['win'] = array(
      'table' => 'leaguesite_sports',
      'field' => 'win',
    );
    $this->additional_fields['draw'] = array(
      'table' => 'leaguesite_sports',
      'field' => 'draw',
    );
    $this->additional_fields['loss'] = array(
      'table' => 'leaguesite_sports',
      'field' => 'loss',
    );
	}
	
	function query(){
		$this->ensure_my_table();
		$this->add_additional_fields();
    //we need to make sure that the fields we need for the games played are added to the query
  }
  
  function render($values){
  	$played = ($values->leaguesite_standings_won * $values->leaguesite_sports_win) + ($values->leaguesite_standings_lost * $values->leaguesite_sports_loss) + ($values->leaguesite_standings_drawn * $values->leaguesite_sports_draw) + $values->leaguesite_standings_bonus;
  	//for some reason, this comes out as blank when a zero is returned. Not a massive problem, however as you can just use the empty text to display a zero
  	return $played;
  }
}